/*
  Rhino test framework

   Copyright (C) 2011  Red Hat

This file is part of IcedTea.

IcedTea is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

IcedTea is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with IcedTea; see the file COPYING.  If not, write to the
Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
02110-1301 USA.

Linking this library statically or dynamically with other modules is
making a combined work based on this library.  Thus, the terms and
conditions of the GNU General Public License cover the whole
combination.

As a special exception, the copyright holders of this library give you
permission to link this library with independent modules to produce an
executable, regardless of the license terms of these independent
modules, and to copy and distribute the resulting executable under
terms of your choice, provided that you also meet, for each linked
independent module, the terms and conditions of the license of that
module.  An independent module is a module which is not derived from
or based on this library.  If you modify this library, you may extend
this exception to your version of the library, but you are not
obligated to do so.  If you do not wish to do so, delete this
exception statement from your version.
*/

package org.RhinoTests.TestClasses;

import java.awt.Color;
import java.util.Date;



/**
  * Test class used (called) by various Rhino tests.
  */
public class TestClass {
    /**
     * Private value which can accessed throught getter and setter.
     */
	private String value;

    /**
     * Set the new value of object attribute.
     */
	public void setValue(String value) {
		System.out.println("\tTestClass setter called");
		this.value = value;
	}

    /**
     * Get current value of object attribute.
     */
	public String getValue() {
		System.out.println("\tTestClass getter called");
		return this.value;
	}

    /**
     * Public method which is overloaded (to test Rhino reflection properties)
     */
	public String overloaded(Object o) {
		System.out.println("\toverloaded(object) called with parameter "+ o);
        return "Object";
	}

    /**
     * Public method which is overloaded (to test Rhino reflection properties)
     */
	public String overloaded(String o) {
		System.out.println("\toverloaded(string) called with parameter " + o);
        return "String";
	}

    /**
     * Public method which is overloaded (to test Rhino reflection properties)
     */
	public String overloaded(int o) {
		System.out.println("\toverloaded(int) called with parameter " + o);
        return "Integer";
	}

    /**
     * Public method which is overloaded (to test Rhino reflection properties)
     */
	public String overloaded(double o) {
		System.out.println("\toverloaded(double) called with parameter " + o);
        return "Double";
	}

    /**
     * Public method which is overloaded (to test Rhino reflection properties)
     */
    public String overloaded(Date o) {
        System.out.println("\toverloaded(Date) called with parameter " + o);
        return "Date";
    }

    /**
     * Public method which is overloaded (to test Rhino reflection properties)
     */
    public String overloaded(Color o) {
        System.out.println("\toverloaded(Color) called with parameter " + o);
        return "Color";
    }

    /**
     * Public method which is overloaded (to test Rhino reflection properties)
     */
    public String overloaded(boolean o) {
        System.out.println("\toverloaded(boolean) called with parameter " + o);
        return "boolean";
    }

    /**
     * Public method which is overloaded (to test Rhino reflection properties)
     */
    public String overloaded(Boolean o) {
        System.out.println("\toverloaded(boolean) called with parameter " + o);
        return "Boolean";
    }

    @Override
    public String toString() {
        return "This is TestClass";
    }
}

